## dde-widgets 6.0.23

=== debian/changelog ===
dde-widgets (6.0.23) unstable; urgency=medium

  * fix: The notification center panel is too close to the edge(Issue: https://github.com/linuxdeepin/developer-center/issues/9373)
  * fix: border color issue(Issue: https://github.com/linuxdeepin/developer-center/issues/8342)

 -- Zhang kun <zhangkun2@uniontech.com>  Mon, 24 Jun 2024 10:20:10 +0800

dde-widgets (6.0.22) unstable; urgency=medium

  * fix: Fix notification center geometry not changing with dock(Issue: https://github.com/linuxdeepin/developer-center/issues/8323)

 -- Zhang kun <zhangkun2@uniontech.com>  Mon, 06 May 2024 13:21:44 +0800

dde-widgets (6.0.21) unstable; urgency=medium

  * fix: add/delete button size tweak(https://github.com/linuxdeepin/developer-center/issues/7552)
  * fix: chore: do not hide in debug mode
  * fix: fix: border tearing due to scaling(Issue: https://github.com/linuxdeepin/developer-center/issues/5550)
  * fix:  Notification center widget swap memory display 'nan'(Issue: Issue: https://github.com/linuxdeepin/developer-center/issues/7400)

 -- Zhang kun <zhangkun2@uniontech.com>  Wed, 10 Apr 2024 09:59:47 +0800

dde-widgets (6.0.20) unstable; urgency=medium

  * fix: scroll bar covers the content(Issue: https://github.com/linuxdeepin/developer-center/issues/6744)
  * fix: calendar show incomplete in dde-wigdet
  * fix: slide out animation blinking(Issue: https://github.com/linuxdeepin/developer-center/issues/7177)

 -- Wang Yixue <wangyixue@deepin.org>  Fri, 01 Mar 2024 09:58:03 +0800

dde-widgets (6.0.19) unstable; urgency=medium

  * fix: description text is clipped
  * fix: button show incomplete
  * fix: does not acquire focus after shown

 -- zsien <quezhiyong@deepin.org>  Fri, 26 Jan 2024 09:47:18 +0800

dde-widgets (6.0.18) unstable; urgency=medium

  * fix: collapse button show when full collapsed(Issue: https://github.com/linuxdeepin/developer-center/issues/5362)
  * fix: Fix "undefined reference" errors
    Thanks to Hillwood Yang
  * fix: wrong position when screen changed(Issue: https://github.com/linuxdeepin/developer-center/issues/6867)

 -- YeShanShan <yeshanshan@deepin.org>  Wed, 17 Jan 2024 15:13:59 +0800

dde-widgets (6.0.17) unstable; urgency=medium

  * release 6.0.17
  * fix: dde-widgets window margin error(#4400)
  * update notify clear icon(#6367)

 -- Mike Chen <chenke@deepin.org>  Tue, 09 Jan 2024 17:08:01 +0800

dde-widgets (6.0.16) unstable; urgency=medium

  * release 6.0.16
  * fix #4907

 -- Mike Chen <chenke@deepin.org>  Thu, 04 Jan 2024 11:17:10 +0800

dde-widgets (6.0.15) unstable; urgency=medium

  * release 6.0.15
  * fix: dde-widgets height error(#5703)
  * fix: description text color error(#2340)
  * feat: Add calendar widget

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 14 Dec 2023 13:17:28 +0800

dde-widgets (6.0.14) unstable; urgency=medium

  * chore: Sync by https://github.com/linuxdeepin/.github/commit/559e91167d4919644f37bbcf123eb0651c1528ea(Influence: none)
  * chore: adjust the include files in main.cpp
  * fix: clock drawing error
  * fix: widget's not in center(Issue: https://github.com/linuxdeepin/developer-center/issues/5256)
  * fix: UI error on collapse mode(Issue: https://github.com/linuxdeepin/developer-center/issues/4642)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 30 Aug 2023 10:59:26 +0800

dde-widgets (6.0.13) unstable; urgency=medium

  * chore: Sync by https://github.com/linuxdeepin/.github/commit/2e5e092ba3f86b16d1aabbabcf0bfd2ae65b19c8(Influence: none)
  * fix: never install to home when released
  * feat: Use find_program to find qdbusxml2cpp-fix
  * fix: do not hardcord libdir
    Thanks to Hillwood Yang
  * chore: avoid use hardcode path in services
  * fix: build error due to xml2cpp varible's change in dtkcore
  * feat: support tzdir variable
  * fix: widget in cell isn't center-align(Issue: #22)
  * fix: font size don't synchronize changes(Issue: #5)
  * fix: set offset diff to local time
    Thanks to rewine
  * chore(CI): Update obs tag build workflow
  * Revert "fix: 修复玲珑应用通知无法跳转"
  * fix: 调整关于对话框的文字排版

 -- Deepin Packages Builder <packages@deepin.org>  Tue, 04 Jul 2023 15:56:08 +0800

dde-widgets (6.0.12) unstable; urgency=medium

  * fix: Icon blur in high devicePixelRatio(Issue: https://github.com/linuxdeepin/dde-widgets/issues/4)
  * fix: WidgetStore's widget is blur
  * feat: Add startup parameter to show dde-widgets
  * chore: Removing cppcheck warning

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 21 Apr 2023 20:09:01 +0800

dde-widgets (6.0.11) unstable; urgency=medium

  * fix: 修复玲珑应用通知无法跳转
  * chore: Compile error
  * fix: Adaptor XEventMonitor1 updated(Issue: https://github.com/linuxdeepin/developer-center/issues/4132)

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 20 Apr 2023 13:41:28 +0800

dde-widgets (6.0.10) unstable; urgency=medium

  * fix: Remove aliasing for Panel.
  * fix: Add blur background for frame.
  * fix: incorrent background for memory and clock Widget.

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 30 Mar 2023 14:35:56 +0800

dde-widgets (6.0.8) unstable; urgency=medium

  [ TagBuilder ]
  * fix: 修复显示面板里编辑按钮被遮住(Bug: 181491)(Influence: 显示面板)
  * fix: 修复不同语言下按钮显示不全(Bug: 184126)(Influence: 编辑面板)

 -- lvpeilong <lvpeilong@uniontech.com>  Mon, 16 Jan 2023 10:01:05 +0800

dde-widgets (6.0.7) unstable; urgency=medium

  [ TagBuilder ]
  * fix: 修复缩放调整为1以上时 时钟面板指针显示错位(Task: 234687)(Influence: 时钟小组件时间显示)
  * fix: 修复时钟小组件中各地区的时间显示均相同(Bug: 181489)(Influence: 时钟小组件时间显示)

 -- lvpeilong <lvpeilong@uniontech.com>  Fri, 06 Jan 2023 15:50:04 +0800

dde-widgets (6.0.6) unstable; urgency=medium

  [ TagBuilder ]
  * fix: 修复桌面的通知中心的通知设置按钮点击无效(Bug: 181065)(Influence: 通知中心调起控制中心通知模块)
  * fix: 修复桌面的通知中心的通知设置按钮点击无效2(Bug: 181065)(Influence: 通知中心调起控制中心通知模块)

 -- zhaoyingzhen <zhaoyingzhen@uniontech.com>  Wed, 04 Jan 2023 11:51:13 +0800

dde-widgets (6.0.5) unstable; urgency=medium

  [ TagBuilder ]
  * fix: 组件面板消失后，自定义的窗口仍然存在(Bug: 166183)(Influence: 时钟组件设置弹出时收起面板效果)


## dde-widgets 6.0.25

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(VERSION 3.7)

project(dde-widgets)

set(CMAKE_CXX_STANDARD 17)
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

include(GNUInstallDirs)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -fno-omit-frame-pointer")
else ()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif ()

add_definitions(-DDefaultPluginDirectory="${CMAKE_INSTALL_FULL_LIBDIR}/dde-widgets/plugins")

include_directories(
    ${PROJECT_SOURCE_DIR}/app/utils/dbus/xml2cpp/types/
    ${PROJECT_SOURCE_DIR}/app/utils/dbus/xml2cpp/
)

add_subdirectory(interface)
add_subdirectory(app)
add_subdirectory(tests)

# buildin widgets.
add_subdirectory(notification)
add_subdirectory(memorymonitor)
add_subdirectory(worldclock)
add_subdirectory(calendar)

# Only build example when dde-widgets-dev in installed.
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    find_package(DdeWidgets QUIET)
    if (DdeWidgets_FOUND)
        add_subdirectory(example)
    endif()
endif()

file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dde-widgets/translations)

=== app/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

PROJECT(frame)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets DBus Concurrent)
find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)

find_package(PkgConfig REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

set(XML2CPP_DIR ${PROJECT_SOURCE_DIR}/utils/dbus/xml2cpp)

#dbus xml
find_package(DtkTools REQUIRED)

function(generation_dbus_interface xml class_name class_file)
    execute_process(COMMAND ${DTK_XML2CPP} -c ${class_name} -p ${class_file} ${xml}
        WORKING_DIRECTORY ${XML2CPP_DIR})
endfunction(generation_dbus_interface)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/xml/org.deepin.dde.Appearance1.xml
    Appearance
    ${XML2CPP_DIR}/appearance_interface
)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/xml/org.deepin.dde.daemon.Dock1.xml
    Dock
    ${XML2CPP_DIR}/dock_interface
)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/xml/org.deepin.dde.Display1.Monitor.xml
    Monitor
    ${XML2CPP_DIR}/monitor_interface
)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/xml/org.deepin.dde.Display1.xml
    Display
    ${XML2CPP_DIR}/display_interface
)

file(GLOB DBUS_TYPES "utils/dbus/xml2cpp/types/*.*")
file(GLOB DBUS_INTERFACES "utils/dbus/xml2cpp/*.*")

include(src.cmake)


ADD_EXECUTABLE(${PROJECT_NAME}
    main.cpp
    ${HEADERS}
    ${SOURCES}
    ${DBUS_XML}
    ${DBUS_TYPES}
    ${DBUS_INTERFACES}
)

SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME dde-widgets)

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    Qt5::Concurrent
    ${DtkWidget_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME} PUBLIC ${COMMON_LIBS})
target_link_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_BINARY_DIR}/../interface)
target_link_libraries(${PROJECT_NAME} PRIVATE dde-widgets)

target_include_directories(${PROJECT_NAME} PUBLIC
    Qt5::Concurrent
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
    dbus/xml2cpp/
)

install(FILES services/org.deepin.dde.Widgets1.service DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dbus-1/services)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)

configure_file(
	${CMAKE_SOURCE_DIR}/app/services/systemd/dde-widgets.service.in
	${CMAKE_CURRENT_BINARY_DIR}/dde-widgets.service
	@ONLY)
set(SYSTEMD_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/dde-widgets.service
)

macro(install_symlink filepath wantsdir)
    file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/link/${wantsdir}/)
    execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_INSTALL_PREFIX}/lib/systemd/user/${filepath} ${PROJECT_BINARY_DIR}/link/${wantsdir}/${filepath})
    install(FILES ${PROJECT_BINARY_DIR}/link/${wantsdir}/${filepath} DESTINATION lib/systemd/user/${wantsdir}/)
endmacro(install_symlink)

install(FILES ${SYSTEMD_FILES} DESTINATION lib/systemd/user/)
install(DIRECTORY DESTINATION lib/systemd/user/dde-osd.target.wants/)
install_symlink(dde-widgets.service dde-osd.target.wants)

=== calendar/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

PROJECT(dde-calendarwidget-plugin)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets DBus)
find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

SET(LIBRARY_OUTPUT_PATH ../app/plugins)
add_library(${PROJECT_NAME} SHARED plugin.h plugin.cpp)

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    ${DtkWidget_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME} PUBLIC ${COMMON_LIBS})
target_link_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_BINARY_DIR}/../interface)
target_link_libraries(${PROJECT_NAME} PRIVATE dde-widgets)

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
)
include_directories(../interface/)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-widgets/plugins)

=== example/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

PROJECT(dde-examplewidget-plugin)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets)

find_package(DdeWidgets REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

SET(LIBRARY_OUTPUT_PATH ../app/plugins)
add_library(${PROJECT_NAME} SHARED plugin.h plugin.cpp)

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    ${DdeWidgets_LIBRARIES}
)

target_include_directories(${PROJECT_NAME} PUBLIC ${DdeWidgets_INCLUDE_DIR})

target_link_libraries(${PROJECT_NAME} PUBLIC ${COMMON_LIBS})

install_dde_widgets_plugin(${PROJECT_NAME})

=== interface/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

PROJECT(interface)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

file(GLOB INTERFACES
    widgetsglobal.h
    widgetsinterface.h)

set(HEADERS
    ${INTERFACES}
    widgetsinterface_p.h
)
set(SOURCES
    widgetsinterface.cpp
)

add_library(${PROJECT_NAME} SHARED ${HEADERS} ${SOURCES})
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME dde-widgets)

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
)

target_link_libraries(${PROJECT_NAME} PUBLIC ${COMMON_LIBS})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

set(INCLUDE_INSTALL_DIR include/dde-widgets)
set(PLUGIN_INSTALL_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/dde-widgets/plugins)
install(FILES ${INTERFACES} DESTINATION include/dde-widgets)

include(CMakePackageConfigHelpers)
configure_package_config_file(DdeWidgetsConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/DdeWidgetsConfig.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeWidgets
    PATH_VARS INCLUDE_INSTALL_DIR PLUGIN_INSTALL_DIR
    INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeWidgetsConfig.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeWidgets)

=== memorymonitor/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

PROJECT(dde-memorymonitorwidget-plugin)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets DBus)
find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

include(src.cmake)

SET(LIBRARY_OUTPUT_PATH ../app/plugins)
add_library(${PROJECT_NAME} MODULE plugin.h plugin.cpp ${SOURCES} ${HEADERS})

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    ${DtkWidget_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME} PRIVATE ${COMMON_LIBS})

target_include_directories(${PROJECT_NAME} PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
)
include_directories(../interface/)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-widgets/plugins)

=== notification/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

PROJECT(dde-notificationwidget-plugin)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets DBus Concurrent Svg X11Extras)
find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

set(XML2CPP_DIR ${PROJECT_SOURCE_DIR}/utils/dbus/xml2cpp)

#dbus xml
find_package(DtkTools REQUIRED)

function(generation_dbus_interface xml class_name class_file)
    execute_process(COMMAND ${DTK_XML2CPP} -c ${class_name} -p ${class_file} ${xml}
        WORKING_DIRECTORY ${XML2CPP_DIR})
endfunction(generation_dbus_interface)

generation_dbus_interface(
    ${CMAKE_SOURCE_DIR}/xml/org.deepin.dde.daemon.Launcher1.xml
    Launcher
    ${XML2CPP_DIR}/launcher_interface
)
file(GLOB DBUS_TYPES "utils/dbus/xml2cpp/types/*.*")
file(GLOB DBUS_INTERFACES "utils/dbus/xml2cpp/*.*")

include(src.cmake)

SET(LIBRARY_OUTPUT_PATH ../app/plugins)
add_library(${PROJECT_NAME} MODULE
    plugin.h
    plugin.cpp
    ${SOURCES}
    ${HEADERS}
    image.qrc
    ${DBUS_TYPES}
    ${DBUS_INTERFACES}
)

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    Qt5::Concurrent
    Qt5::Svg
    Qt5::X11Extras
    ${DtkWidget_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME} PRIVATE ${COMMON_LIBS})

target_include_directories(${PROJECT_NAME} PRIVATE
    Qt5::Concurrent
    Qt5::Svg
    Qt5::X11Extras
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
    utils/dbus/xml2cpp/
    utils/dbus/xml2cpp/types/
)
include_directories(
    ../interface/
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-widgets/plugins)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets DBus)
find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)

find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Test)

# generate moc_predefs.h
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

set(DTK_HAS_UNIT_TEST ON)
# for coverage
if (DTK_HAS_UNIT_TEST)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lgcov --coverage")
endif()

include(../app/src.cmake)

list(APPEND HEADERS
    ../interface/widgetsglobal.h
    ../interface/widgetsinterface.h
    ../interface/widgetsinterface_p.h)

list(APPEND SOURCES
    ../interface/widgetsinterface.cpp)

list(
    APPEND SOURCES
    ut_widgetsmanager.cpp
    ut_instancemodel.cpp
)

file(GLOB DBUS_TYPES "../app/utils/dbus/xml2cpp/types/*.*")
file(GLOB DBUS_INTERFACES "../app/utils/dbus/xml2cpp/*.*")

ADD_EXECUTABLE(dde-widgets-test
    main.cpp
    ${HEADERS}
    ${SOURCES}
    ${DBUS_XML}
    ${DBUS_TYPES}
    ${DBUS_INTERFACES}
    ${DBUS_EXTENDED}
)

target_include_directories(dde-widgets-test PUBLIC
    ../app
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
)

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::Test
    Qt5::DBus
    ${DtkWidget_LIBRARIES}
)

target_link_libraries(dde-widgets-test PUBLIC ${COMMON_LIBS}
    -lgtest
    -lpthread
)

=== worldclock/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

PROJECT(dde-worldclockwidget-plugin)
CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

set(REQUIRED_QT_VERSION 5.11.3)
find_package(Qt5 ${REQUIRED_QT_VERSION} REQUIRED COMPONENTS Core Gui Widgets DBus)
find_package(DtkCore REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkWidget REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(AUTOMOC_COMPILER_PREDEFINES ON)

include(src.cmake)

SET(LIBRARY_OUTPUT_PATH ../app/plugins)
add_library(${PROJECT_NAME} MODULE plugin.h plugin.cpp ${SOURCES} ${HEADERS} qrc/datetime.qrc)

set(COMMON_LIBS
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::DBus
    ${DtkWidget_LIBRARIES}
)

target_link_libraries(${PROJECT_NAME} PRIVATE ${COMMON_LIBS})

target_include_directories(${PROJECT_NAME} PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}
    ${DtkWidget_INCLUDE_DIRS}
)
include_directories(../interface/)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-widgets/plugins)

=== debian/changelog ===
dde-widgets (6.0.25) unstable; urgency=medium

  * fix: window radius isn't changed

 -- xionglinlin <xionglinlin@uniontech.com>  Wed, 25 Sep 2024 18:05:23 +0800

dde-widgets (6.0.24) unstable; urgency=medium

  * fix: show hidden animation lag(Issue: https://github.com/linuxdeepin/developer-center/issues/9728)

 -- Zhang Kun <zhangkun2@uniontech.com>  Wed, 28 Aug 2024 18:00:20 +0800

=== debian/control ===
Source: dde-widgets
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <yeshanshan@uniontech.com>
Build-Depends:
 debhelper (>=9),
 pkg-config,
 cmake,
 qtbase5-dev,
 libdtkcommon-dev,
 libdtkcore-dev (>>5.6.12),
 libdtkcore5-bin,
 libdtkgui-dev,
 libdtkwidget-dev,
 libgtest-dev
Standards-Version: 4.3.0

Package: dde-widgets
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 dde-daemon (>=5.13.27)
Description: deepin desktop-environment - widgets module
 widgets module of deepin desktop-environment.

Package: dde-widgets-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: deepin desktop-environment - widgets module development files
 widgets module development files of deepin desktop-environment
